
--[[

	Settings window related functions

]]--


function BBarTab_OnClick(id)

	_G["BBarSettingsFrameTab1"]:SetChecked(nil);
	_G["BBarSettingsFrameTab2"]:SetChecked(nil);
	_G["BBarSettingsFrameTab3"]:SetChecked(nil);
	_G["BBarSettingsFrameTab4"]:SetChecked(nil);
	_G["BBarSettingsFrameTabS"]:SetChecked(nil);

	g_BBar.InfoScrollFrame:Hide();
	g_BBar.CurrencyScrollFrame:Hide();
	_G["BBarSettingsFrameDropArea"]:Hide();
	_G["BBarSettingsFrameScrollBack"]:SetSize(353, 423);
	g_BBar.RepScrollFrame:Hide();
	g_BBar.ProfFrame:Hide();
	g_BBar.OptionsFrame:Hide();

	g_BBar.CurrentSettingsTab = id;
	if(g_BBar.CurrentSettingsTab == 1) then		-- Info
		_G["BBarSettingsFrameTab1"]:SetChecked(1);
		g_BBar.InfoScrollFrame:Show();
	end
	if(g_BBar.CurrentSettingsTab == 2) then		-- Currencies
		_G["BBarSettingsFrameTab2"]:SetChecked(1);
		_G["BBarSettingsFrameDropArea"]:Show();
		_G["BBarSettingsFrameScrollBack"]:SetSize(353, 398);
		g_BBar.CurrencyScrollFrame:Show();
	end
	if(g_BBar.CurrentSettingsTab == 3) then		-- Reputations
		_G["BBarSettingsFrameTab3"]:SetChecked(1);
		g_BBar.RepScrollFrame:Show();
	end
	if(g_BBar.CurrentSettingsTab == 4) then		-- Professions
		_G["BBarSettingsFrameTab4"]:SetChecked(1);
		g_BBar.ProfFrame:Show();
	end
	if(g_BBar.CurrentSettingsTab == 10) then	-- Settings
		_G["BBarSettingsFrameTabS"]:SetChecked(1);
		g_BBar.OptionsFrame:Show();
	end
end


function BBar_SettingsCheckOnClick(self)

	local obj = self:GetParent();
	if(obj.positionID < 100) then
		g_BBar.BBarObjects_Shown[obj.positionID] = _C(self:GetChecked(), 1, 0);
	else
		g_BBar.BBarObjectsItems_Shown[obj.positionID - 100] = _C(self:GetChecked(), 1, 0);
	end
	BBar_UpdateBar();
	ValuesToString();	-- Store changes
end


function BBar_SettingsRemoveOnClick(self)

	local iPos = self:GetParent().positionID - 100;

	-- Remove it from the bar while it's still valid
	g_BBar.BBarObjectsItems_Shown[iPos] = 0;
	BBar_UpdateBar();

	-- Remove it completly
	g_BBar.BBarObjectsItems[iPos] = 0;
	BBar_UpdateSettings();
	ValuesToString();	-- Store changes
end


function BBar_SettingsRepShowOnClick(self)

	local obj = self:GetParent();
	g_BBar.BBarObjectsReps_Faction[obj.pos] = { obj.factionID, _C(self:GetChecked(), 1, 0) }
	BBar_UpdateBar();
	ValuesToString();	-- Store changes
end


function BBar_SettingsProfShowOnClick(self)

	local obj = self:GetParent();
	g_BBar.BBarObjectsProfs_Shown[obj.pos] = _C(self:GetChecked(), 1, 0);
	BBar_UpdateBar();
	ValuesToString();	-- Store changes
end


function BBar_AcceptItem(infoType, itemID)

	-- Add the item to the custom items list
	if(infoType == "item") then
		-- Check it's not already added
		for i = 1, getn(g_BBar.BBarObjectsItems), 1 do
			if(g_BBar.BBarObjectsItems[i] == itemID) then
				ClearCursor();
				return;
			end
		end

		-- Add it to the end of the list
		local iPos = getn(g_BBar.BBarObjectsItems) + 1;
		g_BBar.BBarObjectsItems[iPos] = itemID;
		g_BBar.BBarObjectsItems_Shown[iPos] = 1;	-- Shown as default
		ClearCursor();
		BBar_UpdateBar();
		BBar_UpdateSettings();
		ValuesToString();	-- Store changes
	end
end


function BBar_HandleModifiedItemClick(link)

	if(IsAltKeyDown()) then
		local justID = string.gsub(link,".-\124H([^\124]*)\124h.*", "%1")
		local infoType, itemID = strsplit(":",justID);	-- enchantId, jewelId1, jewelId2, jewelId3, jewelId4, suffixId, uniqueId, linkLevel, reforgeId = strsplit(":",justID)
		local itemName, _, itemQuality = GetItemInfo(itemID);

		if(infoType == "item") then	-- Ask if it should be added
			_G["BBarAddItem"].infoType = infoType;
			_G["BBarAddItem"].itemID = tonumber(itemID);
			_G["BBarAddItemItem"]:SetText(itemName);
			_G["BBarAddItemItem"]:SetTextColor(GetItemQualityColor(itemQuality));
			_G["BBarAddItemIcon"]:SetTexture(GetItemIcon(itemID));
			_G["BBarAddItem"]:Show();
		end
	end
end


---------------------------


function BBar_BuildSettingsFrame()		-- Create the settings window, only called once

	-- Infomation window
	g_BBar.InfoScrollFrame = CreateFrame("ScrollFrame", "InfoScrollFrame", _G["BBarSettingsFrame"], "UIPanelScrollFrameTemplate");
	g_BBar.InfoScrollFrame:SetPoint("TOPLEFT", _G["BBarSettingsFrame"], "TOPLEFT", 14, -30);
	g_BBar.InfoScrollFrame:SetPoint("BOTTOMRIGHT", _G["BBarSettingsFrame"], "BOTTOMRIGHT", -31, 12);

	local scrollChild = CreateFrame("Frame", "BBarScrollFrameChildInfo", g_BBar.InfoScrollFrame);
	scrollChild:EnableMouse(true)
	scrollChild:SetWidth(326);

	-- Reputation scroll window
	g_BBar.RepScrollFrame = CreateFrame("ScrollFrame", "RepScrollFrame", _G["BBarSettingsFrame"], "UIPanelScrollFrameTemplate");
	g_BBar.RepScrollFrame:SetPoint("TOPLEFT", _G["BBarSettingsFrame"], "TOPLEFT", 14, -30);
	g_BBar.RepScrollFrame:SetPoint("BOTTOMRIGHT", _G["BBarSettingsFrame"], "BOTTOMRIGHT", -31, 12);

	scrollChild = CreateFrame("Frame", "BBarScrollFrameChildRep", g_BBar.RepScrollFrame);
	scrollChild:EnableMouse(true)
	scrollChild:SetWidth(326);
	g_BBar.RepScrollFrame:Hide();	-- Initially hidden

	-- Professions window
	g_BBar.ProfFrame = CreateFrame("Frame", "ProfessionFrame", _G["BBarSettingsFrame"]);
	g_BBar.ProfFrame:SetPoint("TOPLEFT", _G["BBarSettingsFrame"], "TOPLEFT", 14, -30);
	g_BBar.ProfFrame:SetPoint("BOTTOMRIGHT", _G["BBarSettingsFrame"], "BOTTOMRIGHT", -31, 12);
	g_BBar.ProfFrame:Hide();	-- Initially hidden

	-- Options window
	g_BBar.OptionsFrame = CreateFrame("Frame", "OptionsFrame", _G["BBarSettingsFrame"]);
	g_BBar.OptionsFrame:SetPoint("TOPLEFT", _G["BBarSettingsFrame"], "TOPLEFT", 14, -30);
	g_BBar.OptionsFrame:SetPoint("BOTTOMRIGHT", _G["BBarSettingsFrame"], "BOTTOMRIGHT", -31, 12);
	g_BBar.OptionsFrame:Hide();	-- Initially hidden
	BBar_BuildOptionsFrame();

	-- Currencies scroll window
	g_BBar.CurrencyScrollFrame = CreateFrame("ScrollFrame", "CurrencyScrollFrame", _G["BBarSettingsFrame"], "UIPanelScrollFrameTemplate");
	g_BBar.CurrencyScrollFrame:SetPoint("TOPLEFT", _G["BBarSettingsFrame"], "TOPLEFT", 14, -30);
	g_BBar.CurrencyScrollFrame:SetPoint("BOTTOMRIGHT", _G["BBarSettingsFrame"], "BOTTOMRIGHT", -31, 37);

	scrollChild = CreateFrame("Frame", "BBarScrollFrameChild", g_BBar.CurrencyScrollFrame);
	scrollChild:EnableMouse(true)
	scrollChild:SetWidth(326);
	g_BBar.CurrencyScrollFrame:Hide();	-- Initially hidden

	local scrollChildHeight = 0;
	local priorItem = scrollChild;

	-- Currencies
	for i = 1, g_BBar.TOTALITEMS, 1 do
		if(g_BBar.BBarObjects[i] < g_BBar.MINCURRENCYID) then
			if(g_BBar.BBarObjects[i] == 1) then
				priorItem = BBar_CreateCurrencyItem("Money", "", scrollChild, priorItem, i);
				scrollChildHeight = scrollChildHeight + 26;
			elseif (g_BBar.BBarObjects[i] == 2) then
				priorItem = BBar_CreateCurrencyItem("Points", "", scrollChild, priorItem, i);
				scrollChildHeight = scrollChildHeight + 26;
			elseif (g_BBar.BBarObjects[i] == 3) then
				priorItem = BBar_CreateCurrencyItem("Professions", "", scrollChild, priorItem, i);
				scrollChildHeight = scrollChildHeight + 26;
			elseif (g_BBar.BBarObjects[i] == 4) then
				priorItem = BBar_CreateCurrencyItem("Items", "", scrollChild, priorItem, i);
				scrollChildHeight = scrollChildHeight + 26;
			elseif (g_BBar.BBarObjects[i] == 5) then
				priorItem = BBar_CreateCurrencyItem("Archaeology", "", scrollChild, priorItem, i);
				scrollChildHeight = scrollChildHeight + 26;
			elseif (g_BBar.BBarObjects[i] == 6) then
				priorItem = BBar_CreateCurrencyItem("Custom Items", "", scrollChild, priorItem, i);
				scrollChildHeight = scrollChildHeight + 26;
			end
		elseif (g_BBar.BBarObjects[i] > g_BBar.MINCURRENCYID) then
			local name, count, icon;
			if(g_BBar.BBarObjects[i] == g_BBar.MONEYID) then
				name = "Character Gold";
				count = 0;
				icon = "Interface\\MoneyFrame\\UI-MoneyIcons";
			else
				name, count, icon = GetCurrencyInfo(g_BBar.BBarObjects[i]);
			end
			priorItem = BBar_CreateCurrencyItem(name, icon, scrollChild, priorItem, i);
			priorItem.currencyID = g_BBar.BBarObjects[i];
			scrollChildHeight = scrollChildHeight + 24;
		end
	end

	-- Store some values for use when we add the custom items
	g_BBar.lastSettingsItem = priorItem;
	g_BBar.defaultSettingsheight = scrollChildHeight;

	scrollChild:SetHeight(scrollChildHeight);
	g_BBar.CurrencyScrollFrame:SetScrollChild(scrollChild);
end


function BBar_UpdateSettings()			-- Called each time the window is shown

	BBar_UpdateInfoPage();				-- Create the Info page
	BBar_UpdateCurrencyItems();			-- Load/Update the currencies
	BBar_BuildReputationFrame();		-- Load/Update the reputations
	BBar_BuildProfessionFrame();		-- Load/Update the professions
	BBar_UpdateOptionsFrame();			-- Update the options window
end

----------------------------------------------
-- Information

function BBar_CreateTextObject(name, text, parent, size, r, g, b, a, x, y, width, height)
	local textObj = parent:CreateFontString(name, nil, "GameFontNormal")
	if(size) then textObj:SetFont(textObj:GetFont(), size); end
	textObj:SetPoint("TOPLEFT", parent, "TOPLEFT", x, y)
	textObj:SetTextColor(r, g, b, a)
	textObj:SetText(text)
	textObj:SetJustifyH("LEFT")
	textObj:SetWidth(width or textObj:GetWidth())
	textObj:SetHeight(height or textObj:GetHeight())
	return textObj;
end

function BBar_CreateDrawnLine(name, parent, xPos, yPos, width)
	local texture = _G[name];
	if( not texture ) then
		texture = parent:CreateTexture(name);
	else	texture:ClearAllPoints();
	end
	texture:SetTexture("Interface\\Buttons\\UI-Panel-Button-Disabled");
	texture:SetTexCoord(0.3, 0.5, 0.62, 0.7);
	texture:SetBlendMode("ADD");
	texture:SetVertexColor(1, 1, 1, 0.5);
	texture:SetSize(width, 2);
	texture:SetPoint("TOP", parent, "TOP", xPos, yPos);
	return texture;
end

function BBar_CreateRaidObject(parent, name, difficulty, encounterProgress, numEncounters, alpha, iPos, i, id)
	-- Create the default data
	local item = _G["BBarRaidItem"..iPos];
	if( not item ) then
		item = CreateFrame("Frame", "BBarRaidItem"..iPos, parent, "BBarSettingsRaidTemplate");
	else	item:ClearAllPoints();
	end
	item.barType = 4;
	item.instID = tostring(id);
	item:SetID(i);
	item:SetAlpha(alpha);
	_G[item:GetName().."Name"]:SetText(name);
	_G[item:GetName().."Difficulty"]:SetText(difficulty);
	_G[item:GetName().."Progress"]:SetText(tostring(encounterProgress).."/"..tostring(numEncounters));
	if(numEncounters == encounterProgress) then _G[item:GetName().."Progress"]:SetTextColor(1, 0.1, 0.1, 1); end
	_G[item:GetName().."ID"]:SetText("("..tostring(id)..")");
	item:Show();
	return item;
end

function BBar_ShowRaidObjectTooltip(self)

	GameTooltip:SetOwner(self, "ANCHOR_TOPLEFT");
	if(g_BBar.InfoShowExpired == 1) then	GameTooltip:SetText("Hide Expired Instances", 1, 1, 1);
	else	GameTooltip:SetText("Show Expired Instances", 1, 1, 1);
	end
	GameTooltip:Show();
end

function BBar_UpdateInfoPage()		-- Called each time the window is shown

	local scrollChild = _G["BBarScrollFrameChildInfo"];

	if(g_BBar.InfoBaseHeight < 1) then

	-- Create the default data
		local tObj = BBar_CreateTextObject(nil, "BBar", scrollChild, 20, 0.6, 0.5 ,1.0, 1, 0, -12, scrollChild:GetWidth(), nil);
		tObj:SetJustifyH("CENTER")
		tObj = BBar_CreateTextObject(nil, "[ Made by Bynun ]", scrollChild, 10, 0.2, 1 , 0.2, 1, 220, -2, nil, nil);
		local yPos = -46;
		tObj = BBar_CreateTextObject(nil, "|cffffffff::|r |cff44ff44/bbar|r Reset the bars position to the center of the screen.", scrollChild, 10, 0.8, 0.8, 0.8, 1, 4, yPos, scrollChild:GetWidth(), nil);
		yPos = yPos - (tObj:GetHeight() + 8);
		tObj = BBar_CreateTextObject(nil, "|cffffffff::|r To add a custom item to the bar...", scrollChild, 10, 0.8, 0.8, 0.8, 1, 4, yPos, scrollChild:GetWidth(), nil);
		yPos = yPos - (tObj:GetHeight() + 4);
		tObj = BBar_CreateTextObject(nil, "    Drag it from your bag to the currencies window", scrollChild, 10, 0.8, 0.8, 0.8, 1, 4, yPos, scrollChild:GetWidth(), nil);
		yPos = yPos - (tObj:GetHeight() + 4);
		tObj = BBar_CreateTextObject(nil, "    or hold 'alt' and click the bag/bank item.", scrollChild, 10, 0.8, 0.8, 0.8, 1, 4, yPos, scrollChild:GetWidth(), nil);
		yPos = yPos - (tObj:GetHeight() + 4);
		tObj = BBar_CreateTextObject(nil, "    You can display an unlimited number of items.", scrollChild, 10, 0.8, 0.8, 0.8, 1, 4, yPos, scrollChild:GetWidth(), nil);
		yPos = yPos - (tObj:GetHeight() + 4);
		tObj = BBar_CreateTextObject(nil, "    Item count includes all bag and bank items of that type.", scrollChild, 10, 0.8, 0.8, 0.8, 1, 4, yPos, scrollChild:GetWidth(), nil);

		yPos = yPos - (tObj:GetHeight() + 24);
		tObj = BBar_CreateTextObject("BBarInfoTotalTime", "", scrollChild, 12, 1, 1, 1, 1, 0, yPos, scrollChild:GetWidth(), nil);
		tObj:SetJustifyH("CENTER")
		yPos = yPos - (tObj:GetHeight() + 16);
		tObj = BBar_CreateTextObject("BBarInfoLevelTime", "", scrollChild, 12, 1, 1, 1, 1, 0, yPos, scrollChild:GetWidth(), nil);
		tObj:SetJustifyH("CENTER")
		yPos = yPos - (tObj:GetHeight() + 24);

		BBar_CreateDrawnLine("BBarInfoPageLine", scrollChild, 0, yPos, 300);
		yPos = yPos - 18;

		tObj = BBar_CreateTextObject("BBarLockedRaidsText", "Locked Raids", scrollChild, 14, 1, 1, 1, 1, 0, yPos, scrollChild:GetWidth(), nil);
		tObj:SetJustifyH("CENTER")
		g_BBar.InfoBaseHeight = abs(yPos) + (tObj:GetHeight() + 18);
		
		tObj = CreateFrame("Button", "BBarInfoPageRaidButton", scrollChild);
		tObj:SetSize(22, 20);
		tObj:SetBackdrop({bgFile="", edgeFile="Interface\\Tooltips\\UI-Tooltip-Border", tile=true, tileSize=16, edgeSize=10, insets={left=2, right=2, top=2, bottom=2}});
		tObj:SetBackdropBorderColor(1, 1, 1, 0.5);
		tObj:RegisterForClicks("LeftButtonUp");
		tObj:SetScript("OnClick", function(self, button)
			g_BBar.InfoShowExpired = (1 - g_BBar.InfoShowExpired);
			BBar_UpdateInfoPage();	end);
		tObj:SetScript("OnEnter", BBar_ShowRaidObjectTooltip);
		tObj:SetScript("OnLeave", function() GameTooltip:Hide(); end);

		tObj = CreateFrame("Button", "BBarInfoPageRaidButtonAll", scrollChild);
		tObj:SetSize(55, 20);
		tObj.barType = 10;
		tObj:SetBackdrop({bgFile="", edgeFile="Interface\\Tooltips\\UI-Tooltip-Border", tile=true, tileSize=16, edgeSize=10, insets={left=2, right=2, top=2, bottom=2}});
		tObj:SetBackdropBorderColor(1, 1, 1, 0.5);
		tObj:RegisterForClicks("LeftButtonUp", "RightButtonUp");
		tObj:SetScript("OnClick", function(self, button) BBar_DisplayChannelMenu(self, "RightButton")	end);
		local text = tObj:CreateFontString("BBarInfoPageRaidButtonAllT", nil, "GameFontHighlightSmall")
		text:SetSize(55, 20);
		text:SetPoint("TOPLEFT", tObj, "TOPLEFT", 0, 0);
		text:SetText("Print All");
		tObj:SetPoint("TOPRIGHT", scrollChild, "TOPRIGHT", -10, yPos + 10);

	end
	local scrollChildHeight = g_BBar.InfoBaseHeight;

	g_BBar.InfoCaptureTimeChat = 1;
	g_BBar.InfoCaptureTimeWrite = 1;
	RequestTimePlayed();	-- Trigger an update (after the TextObject items have been made)

	-- Add the dynamic data
	local priorItem = _G["BBarLockedRaidsText"];
	local iPos = 1;
	local numInstances = GetNumSavedInstances();

	-- All active instance locks
	for i = 1, numInstances, 1 do
		local name, id, _, _, locked, _, _, _, _, difficultyName, numEncounters, encounterProgress = GetSavedInstanceInfo(i);
		if(locked == true) then
			local item = BBar_CreateRaidObject(scrollChild, name, difficultyName, encounterProgress, numEncounters, 1.0, iPos, i, id)
			item:SetPoint("TOPLEFT", priorItem, "BOTTOMLEFT", 0, -4);
			priorItem = item;
			scrollChildHeight = scrollChildHeight + item:GetHeight();
			iPos = iPos + 1;
		end
	end

	-- Add the expand line and button
	scrollChildHeight = scrollChildHeight + 14
	BBar_CreateDrawnLine("BBarInfoPageRaidLine", scrollChild, 20, -scrollChildHeight, 200);
	priorItem = BBar_CreateTextObject("BBar_Expired_Text", "Expired", scrollChild, 12, 0.8, 0.8, 0.8, 1, 22, -(scrollChildHeight - 6), nil, 12);
	
	local expired = _G["BBarInfoPageRaidButton"];
	expired:ClearAllPoints();
	expired:SetPoint("TOPRIGHT", scrollChild, "TOPRIGHT", -10, -(scrollChildHeight - 10));

	if(g_BBar.InfoShowExpired == 1) then
		expired:SetNormalTexture("Interface\\Buttons\\Arrow-Up-Up");	-- Up arrow
		expired:GetNormalTexture():SetTexCoord(-0.2, 1, 0.1, 1.1);
	else
		expired:SetNormalTexture("Interface\\Buttons\\Arrow-Down-Up");	-- Down arrow
		expired:GetNormalTexture():SetTexCoord(-0.2, 1, -0.3, 0.7);
	end
	expired:GetNormalTexture():SetDesaturated(true);
--	expired:GetNormalTexture():SetVertexColor(0.6, 0.8, 1, 1.0);

	scrollChildHeight = scrollChildHeight + 16;

	if(g_BBar.InfoShowExpired == 1) then
		-- All expired instance locks
		priorItem = nil;
		for i = 1, numInstances, 1 do
			local name, id, reset, _, locked, extended, _, _, _, difficultyName, numEncounters, encounterProgress = GetSavedInstanceInfo(i);
			if(locked == false) then
				local item = BBar_CreateRaidObject(scrollChild, name, difficultyName, encounterProgress, numEncounters, 0.8, iPos, i, id)
				if(priorItem) then
					item:SetPoint("TOPLEFT", priorItem, "BOTTOMLEFT", 0, -4);
				else
					item:SetPoint("TOPLEFT", scrollChild, "TOPLEFT", 0, -scrollChildHeight);
				end
				priorItem = item;
				scrollChildHeight = scrollChildHeight + item:GetHeight();
				iPos = iPos + 1;
			end
		end
	end

	-- Scroll through any other created raid item frames to hide them
	for i = iPos, 100, 1 do
		local item = _G["BBarRaidItem"..i];
		if(item) then item:Hide();	end
	end

	scrollChild:SetHeight(scrollChildHeight);
	g_BBar.InfoScrollFrame:SetScrollChild(scrollChild);

end

----------------------------------------------
-- Currencies

function BBar_UpdateCurrencyItems()		-- Called each time the window is shown

-- Set the check boxes depending on if they are shown
	for i = 1, g_BBar.TOTALITEMS, 1 do
		if(g_BBar.BBarObjects[i] > g_BBar.MINCURRENCYID and g_BBar.BBarObjects_Shown[i] > 0) then
			_G["BBarSettingsItem"..i.."Check"]:SetChecked(true);
		else
			_G["BBarSettingsItem"..i.."Check"]:SetChecked(false);
		end
	end

	-- Custom items
	local scrollChild = _G["BBarScrollFrameChild"];
	local priorItem = g_BBar.lastSettingsItem;
	local scrollChildHeight = g_BBar.defaultSettingsheight;

	local name = "";
	local icon = "";
	local numAdded = 0;
	for i = 1, getn(g_BBar.BBarObjectsItems), 1 do
		name = GetItemInfo(g_BBar.BBarObjectsItems[i]);
		icon = GetItemIcon(g_BBar.BBarObjectsItems[i]);
		local returnItem = BBar_CreateCurrencyItem(name, icon, scrollChild, priorItem, i + 100);
		if(returnItem ~= priorItem) then
			priorItem = returnItem;
			priorItem.currencyID = -g_BBar.BBarObjectsItems[i];
			scrollChildHeight = scrollChildHeight + 30;
			if(g_BBar.BBarObjectsItems_Shown[i] > 0) then
				_G["BBarSettingsItem"..(i + 100).."Check"]:SetChecked(true);
			else
				_G["BBarSettingsItem"..(i + 100).."Check"]:SetChecked(false);
			end
			numAdded = numAdded + 1;
		end
	end
	-- Add 'No custom items' text if needed
	local returnItem = BBar_CreateCurrencyItem("No custom items", "", scrollChild, priorItem, 100);
	if(numAdded == 0) then
		returnItem:Show();
		scrollChildHeight = scrollChildHeight + 30;
	else	returnItem:Hide();
	end
	scrollChild:SetHeight(scrollChildHeight);
end


function BBar_CreateCurrencyItem(name, icon, parent, priorItem, iPos)

	-- If this item doesn't exist yet, create it
	local item = _G["BBarSettingsItem"..iPos];
	if( not item ) then
		item = CreateFrame("Frame", "BBarSettingsItem"..iPos, parent, "BBarSettingsItemTemplate");
	else	item:ClearAllPoints();
	end
	local textItem = _G[item:GetName().."Text"];
	textItem:SetText(name);

	local obj = -1;		-- Custom item
	if(iPos < 100) then	obj = g_BBar.BBarObjects[iPos];	end

	if(iPos == 100) then	-- Special text only item (not title, e.g. "No custom items")
		_G[item:GetName().."Icon"]:Hide();
		_G[item:GetName().."Check"]:Hide();
		_G[item:GetName().."Remove"]:Hide();
	elseif(obj > 0 and obj < g_BBar.MINCURRENCYID) then		-- Title
		textItem:SetPoint("TOPLEFT", 26, -6);	-- Move the text down
		textItem:SetWidth(260);					-- Widen it for proper spacing
		textItem:SetJustifyH("CENTER");
		textItem:SetTextColor(0.8, 1, 0.7, 1);
		_G[item:GetName().."Check"]:Hide();
		_G[item:GetName().."Remove"]:Hide();

		if(obj == 1) then	-- The first item needs to be setup relative to the scroll child
			item:SetPoint("TOP", parent, "TOP", 0, 4);
			return item;
		end
	else
		if(obj < 0) then	-- Custom item!
			if(g_BBar.BBarObjectsItems[iPos - 100] > 0) then	-- Only show valid ones
				local _, _, itemQuality = GetItemInfo(g_BBar.BBarObjectsItems[iPos - 100]);
				if(itemQuality ~= nil) then		textItem:SetTextColor(GetItemQualityColor(itemQuality));	end
				_G[item:GetName().."Icon"]:SetTexture(icon);
				_G[item:GetName().."Check"]:Show();
				_G[item:GetName().."Remove"]:Show();
			else
				item:Hide();
				return priorItem;	-- Skip it
			end
		else				-- Currency
			local tex = _G[item:GetName().."Icon"];
			if(obj == g_BBar.MONEYID) then
					tex:SetTexture(icon);
					tex:SetWidth(20);
					tex:SetHeight(20);
					tex:SetTexCoord(0, 0.25, 0, 1);
			else	tex:SetTexture(icon);
			end
			_G[item:GetName().."Check"]:Show();
			_G[item:GetName().."Remove"]:Hide();
		end
		item.positionID = iPos;
	end
	item:SetPoint("TOPLEFT", priorItem, "BOTTOMLEFT", 0, -4);
	return item;
end

----------------------------------------------
-- Reputations

function BBar_BuildReputationFrame()	-- Create/update the settings reputation window

	ExpandAllFactionHeaders();	-- Make everything visable to me

	local scrollChild = _G["BBarScrollFrameChildRep"];
	local scrollChildHeight = 0;
	local priorItem = scrollChild;

	-- Reputations
	local priorName = "";
	for i = 1, 200, 1 do

	-- Get the data
		local name, _, standingID, barMin, barMax, barValue, _, _, isHeader, isCollapsed, hasRep, _, isChild, factionID = GetFactionInfo(i);
		if((name == nil) or (name == priorName) or (name == "Other"))	then	break	end;	-- last one reached
		priorName = name;

	-- Create the bar
		local factionRow = _G["BBarSettingsRep"..i];
		if( not factionRow ) then
			factionRow = CreateFrame("Frame", "BBarSettingsRep"..i, scrollChild, "BBarSettingsRepTemplate");
		end
		factionRow.barType = 3;	-- Reputation
		local factionBar =			_G["BBarSettingsRep"..i.."RepBar"];
		local factionTitle =		_G["BBarSettingsRep"..i.."FactionName"];
		local factionCheck =		_G["BBarSettingsRep"..i.."Check"];
		local factionBarFill =		_G["BBarSettingsRep"..i.."RepBarPercentageBar"];
		local factionStanding =		_G["BBarSettingsRep"..i.."RepBarStanding"];

		-- The first item needs to be setup relative to the scroll child
		factionRow:ClearAllPoints();
		if(i == 1) then	factionRow:SetPoint("TOP", scrollChild, "TOP", 0, 0);
		else			factionRow:SetPoint("TOPLEFT", priorItem, "BOTTOMLEFT", 0, 0);
		end
		priorItem = factionRow;
		scrollChildHeight = scrollChildHeight + 22;

	-- Fill it
		factionTitle:SetText(name);
		local factionStandingtext = GetText("FACTION_STANDING_LABEL"..standingID, UnitSex("player"));

		-- Check if this is a friendship faction (members of the Tillers)
		local friendID, friendRep, friendMaxRep, _, _, _, friendTextLevel, friendThresh, nextFriendThresh = GetFriendshipReputation(factionID);
		if(friendID ~= nil) then
	--	_T(name.."  "..tostring(friendRep).."  "..tostring(friendMaxRep).."  "..tostring(friendText).."  "..tostring(friendThresh));
			factionStandingtext = friendTextLevel;
			standingID = 5;		-- Green
			if(nextFriendThresh) then
				barMin, barMax, barValue = friendThresh, nextFriendThresh, friendRep;
			else
				barMin, barMax, barValue = 0, 1, 1;
			end
		else
	--	_T(name.."  "..tostring(barMax).."  "..tostring(barValue).."  "..tostring(barMin));
			barMax = barMax - barMin;
			barValue = barValue - barMin;
			if(barValue < 0) then	barValue = (barMax - barValue);	end
		end
		if(barValue == 0) then
				factionBarFill:Hide();	-- Supplying 0 causes max size
		else	factionBarFill:SetWidth(((factionBar:GetWidth() - 4) / abs(barMax)) * abs(barValue));
		end

		-- Store for later use
		factionBar.standingtext = factionStandingtext;
		factionBar.reptext = tostring(barValue).."/"..tostring(barMax);
		factionRow.factionID = factionID;
		factionRow.pos = i;
		
		factionStanding:SetText(factionStandingtext);
		local color = FACTION_BAR_COLORS[standingID];
		factionBarFill:SetVertexColor(color.r, color.g, color.b, 0.7);

		if(isHeader) then
			factionTitle:SetFontObject(GameFontNormalLeft);
			factionRow:SetHeight(22 + 6);	-- Base + extra
			local point, relativeTo, relativePoint, xOfs, yOfs = factionTitle:GetPoint();
			if(isChild) then
				factionTitle:SetPoint(point, relativeTo, relativePoint, 18, yOfs);
				factionTitle:SetWidth(180 - 18);
			else
				factionTitle:SetPoint(point, relativeTo, relativePoint, 0, yOfs);
				factionTitle:SetWidth(180);
			end
		else
			factionTitle:SetFontObject(GameFontHighlightSmall);
			factionRow:SetHeight(22);
			local point, relativeTo, relativePoint, xOfs, yOfs = factionTitle:GetPoint();
			if(isChild) then
				factionTitle:SetPoint(point, relativeTo, relativePoint, 36, yOfs);
				factionTitle:SetWidth(180 - 36);
			else
				factionTitle:SetPoint(point, relativeTo, relativePoint, 18, yOfs);
				factionTitle:SetWidth(180 - 18);
			end
		end
		if(hasRep or (not isHeader)) then
			factionStanding:Show();
			factionBar:Show();
			factionCheck:Show();
		else
			factionStanding:Hide();
			factionBar:Hide();
			factionCheck:Hide();
		end
		if(g_BBar.BBarObjectsReps_Faction[i] and (g_BBar.BBarObjectsReps_Faction[i][2] > 0)) then
			factionCheck:SetChecked(true);
		else
			factionCheck:SetChecked(false);
		end
	end

	scrollChild:SetHeight(scrollChildHeight);
	g_BBar.RepScrollFrame:SetScrollChild(scrollChild);
end

----------------------------------------------
-- Professions

function BBar_BuildProfessionFrame()

	local mainChild = g_BBar.ProfFrame;
	local priorItem = mainChild;

	-- prof1, prof2, archaeology, fishing, cooking, firstAid
	local professions = {GetProfessions()}
	local i = 1;
	for _, v in pairs(professions) do
		if v then
			local name, icon, rank, maxRank, numSpells, spelloffset = GetProfessionInfo(v);

		-- Create the bar
			local profRow = _G["BBarSettingsProf"..i];
			if( not profRow ) then
				profRow = CreateFrame("Frame", "BBarSettingsProf"..i, mainChild, "BBarSettingsProfTemplate");
			end
			profRow.barType = 5;	-- Settings Profession
			profRow:SetID(spelloffset);
			local factionBar =			_G["BBarSettingsProf"..i.."Bar"];
			local factionIcon =			_G["BBarSettingsProf"..i.."Icon"];
			local factionTitle =		_G["BBarSettingsProf"..i.."Name"];
			local factionCheck =		_G["BBarSettingsProf"..i.."Check"];
			local factionBarFill =		_G["BBarSettingsProf"..i.."BarPercentageBar"];
			local factionValue =		_G["BBarSettingsProf"..i.."BarValue"];

			-- The first item needs to be setup relative to the scroll child
			profRow:ClearAllPoints();
			if(i == 1) then	profRow:SetPoint("TOP", mainChild, "TOP", 12, -10);
			else			profRow:SetPoint("TOPLEFT", priorItem, "BOTTOMLEFT", 0, 0);
			end
			priorItem = profRow;

		-- Fill it
			if(rank == 0) then
					factionBarFill:Hide();	-- Supplying 0 causes max size
			else	factionBarFill:SetWidth((factionBarFill:GetWidth() / abs(maxRank)) * abs(rank));
			end

			profRow.pos = i;
			factionIcon:SetTexture(icon);
			factionTitle:SetText(name);
			factionValue:SetText(tostring(rank).."/"..tostring(maxRank));
			factionBarFill:SetVertexColor(0.1, 1.0, 0.1, 0.4);
			factionValue:Show();
			factionBar:Show();
			factionCheck:Show();
			
			if(g_BBar.BBarObjectsProfs_Shown[i] and (g_BBar.BBarObjectsProfs_Shown[i] > 0)) then
				g_BBar.BBarObjectsProfs_Shown[i] = 1;	-- Incase it because something else
				factionCheck:SetChecked(true);
			else
				factionCheck:SetChecked(false);
			end
			i = i + 1;	-- Move to the next one
		end
	end
end


